ListType (API documentation of hlt.language packages)
Date: 2013-01-30

hlt.language.design.types

## Class ListType

- java.lang.Object
- - hlt.language.design.types.Type
  - - hlt.language.design.types.StaticType
    - - hlt.language.design.types.ConstructedType
      - - hlt.language.design.types.CollectionType
        - - hlt.language.design.types.ListType

- All Implemented Interfaces:
    Collection, Valuable

      public class ListType
      extends CollectionType

  This is the class denoting the type of lists. Types of this kind consist of list types whose elements are of any base type (including lists - thus enabling higher-order lists - and type parameters - thus enabling polymorphic lists).

- - ### Field Summary

    - ### Fields inherited from class hlt.language.design.types.Type

      `ARRAY, BAG, BOOLEAN, BOXABLE, CHAR, CLASS, COLLECTION, CONSTANT, DEFINED, FUNCTION, INT, INT_RANGE, INT_SORT, LIST, NAMED_TUPLE, OBJECT_SORT, PARAMETER, REAL, REAL_RANGE, REAL_SORT, SET, STRING, TUPLE, VOID, VOID_SORT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ListType()` Constructs a polymorphic list type; i.e., one whose base type is a type parameter.
    `ListType(Type baseType)` Constructs a list type with the specified base type.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte` | `kind()` Returns the constant identifying list types; i.e., `Type.LIST`.
    `CollectionType` | `newCollectionType(Type basetype)` Returns a new list type with the specified base type.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class hlt.language.design.types.CollectionType

      `baseType, baseTypeRef, checkOccurrence, copy, eqCode, flatten, getParameters, instantiate, isEqualTo, isEqualTo, isPolymorphic, numberOfTypeComponents, setTypeRefComponent, typeRefComponent, unify, unify`

    - ### Methods inherited from class hlt.language.design.types.Type

      `actualType, array, array, BOOLEAN, BOXED_BOOLEAN, BOXED_CHAR, BOXED_INT, BOXED_REAL, boxSort, CHAR, copy, curry, equals, findValue, getParameters, getValue, INT, is, isBag, isBoolean, isBoxedType, isChar, isCollection, isGlobalUnsafe, isInt, isList, isPrimitive, isReal, isSet, isString, isVoid, kindString, rank, REAL, resetNames, setBoxed, shadowType, sort, standardize, toFullString, toQuantifiedString, toQuantifiedString, typeComponent, unwrapper, value, wrapper`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ListType

          public ListType()

      Constructs a polymorphic list type; i.e., one whose base type is a type parameter.

    - #### ListType

          public ListType(Type baseType)

      Constructs a list type with the specified base type.

  - ### Method Detail

    - #### newCollectionType

          public final CollectionType newCollectionType(Type basetype)

      Returns a new list type with the specified base type.
      Specified by:
        `newCollectionType` in class `CollectionType`

    - #### kind

          public final byte kind()

      Returns the constant identifying list types; i.e., `Type.LIST`.
      Specified by:
        `kind` in class `Type`

    - #### toString

          public final java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`